<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
"mybatis-3-mapper.dtd">
<mapper namespace="com.mortals.xhx.module.device.dao.ibatis.DeviceMessageStatDaoImpl">

    <!-- 字段和属性映射 -->
    <resultMap type="DeviceMessageStatEntity" id="DeviceMessageStatEntity-Map">
            <id  property="id" column="id" />
            <result property="siteId" column="siteId" />
            <result property="productId" column="productId" />
            <result property="productCode" column="productCode" />
            <result property="productName" column="productName" />
            <result property="alarmTotalCount" column="alarmTotalCount" />
            <result property="pushTotalCount" column="pushTotalCount" />
            <result property="uploadMessageTotalCount" column="uploadMessageTotalCount" />
            <result property="downloadMessageTotalCount" column="downloadMessageTotalCount" />
            <result property="year" column="year" />
            <result property="month" column="month" />
            <result property="day" column="day" />
            <result property="createTime" column="createTime" />
            <result property="updateUserId" column="updateUserId" />
            <result property="updateTime" column="updateTime" />
            
    </resultMap>


    <!-- 表所有列 -->
    <sql id="_columns">
        <trim suffixOverrides="," suffix="">
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('id') or colPickMode == 1 and data.containsKey('id')))">
                    a.id,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('siteId') or colPickMode == 1 and data.containsKey('siteId')))">
                    a.siteId,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('productId') or colPickMode == 1 and data.containsKey('productId')))">
                    a.productId,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('productCode') or colPickMode == 1 and data.containsKey('productCode')))">
                    a.productCode,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('productName') or colPickMode == 1 and data.containsKey('productName')))">
                    a.productName,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('alarmTotalCount') or colPickMode == 1 and data.containsKey('alarmTotalCount')))">
                    a.alarmTotalCount,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('pushTotalCount') or colPickMode == 1 and data.containsKey('pushTotalCount')))">
                    a.pushTotalCount,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('uploadMessageTotalCount') or colPickMode == 1 and data.containsKey('uploadMessageTotalCount')))">
                    a.uploadMessageTotalCount,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('downloadMessageTotalCount') or colPickMode == 1 and data.containsKey('downloadMessageTotalCount')))">
                    a.downloadMessageTotalCount,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('year') or colPickMode == 1 and data.containsKey('year')))">
                    a.year,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('month') or colPickMode == 1 and data.containsKey('month')))">
                    a.month,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('day') or colPickMode == 1 and data.containsKey('day')))">
                    a.day,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('createTime') or colPickMode == 1 and data.containsKey('createTime')))">
                    a.createTime,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('updateUserId') or colPickMode == 1 and data.containsKey('updateUserId')))">
                    a.updateUserId,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('updateTime') or colPickMode == 1 and data.containsKey('updateTime')))">
                    a.updateTime,
                </if>
        </trim>
    </sql>
    <!-- 新增 区分主键自增加还是业务插入 -->
    <insert id="insert" parameterType="DeviceMessageStatEntity"  useGeneratedKeys="true" keyProperty="id">
        insert into mortals_xhx_device_message_stat
        (siteId,productId,productCode,productName,alarmTotalCount,pushTotalCount,uploadMessageTotalCount,downloadMessageTotalCount,year,month,day,createTime,updateUserId,updateTime)
        VALUES
        (#{siteId},#{productId},#{productCode},#{productName},#{alarmTotalCount},#{pushTotalCount},#{uploadMessageTotalCount},#{downloadMessageTotalCount},#{year},#{month},#{day},#{createTime},#{updateUserId},#{updateTime})
    </insert>

    <!-- 批量新增 -->
    <insert id="insertBatch" parameterType="paramDto">
        insert into mortals_xhx_device_message_stat
        (siteId,productId,productCode,productName,alarmTotalCount,pushTotalCount,uploadMessageTotalCount,downloadMessageTotalCount,year,month,day,createTime,updateUserId,updateTime)
        VALUES
        <foreach collection="data.dataList" item="item" index="index" separator="," >
            (#{item.siteId},#{item.productId},#{item.productCode},#{item.productName},#{item.alarmTotalCount},#{item.pushTotalCount},#{item.uploadMessageTotalCount},#{item.downloadMessageTotalCount},#{item.year},#{item.month},#{item.day},#{item.createTime},#{item.updateUserId},#{item.updateTime})
        </foreach>
    </insert>


    <!-- 根据ParamDto更新 -->
    <update id="update" parameterType="paramDto">
        update mortals_xhx_device_message_stat as a
        set
        <trim suffixOverrides="," suffix="">
            <if test="(colPickMode==0 and data.containsKey('siteId')) or (colPickMode==1 and !data.containsKey('siteId'))">
                a.siteId=#{data.siteId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('siteIdIncrement')) or (colPickMode==1 and !data.containsKey('siteIdIncrement'))">
                a.siteId=ifnull(a.siteId,0) + #{data.siteIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('productId')) or (colPickMode==1 and !data.containsKey('productId'))">
                a.productId=#{data.productId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('productIdIncrement')) or (colPickMode==1 and !data.containsKey('productIdIncrement'))">
                a.productId=ifnull(a.productId,0) + #{data.productIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('productCode')) or (colPickMode==1 and !data.containsKey('productCode'))">
                a.productCode=#{data.productCode},
            </if>
            <if test="(colPickMode==0 and data.containsKey('productName')) or (colPickMode==1 and !data.containsKey('productName'))">
                a.productName=#{data.productName},
            </if>
            <if test="(colPickMode==0 and data.containsKey('alarmTotalCount')) or (colPickMode==1 and !data.containsKey('alarmTotalCount'))">
                a.alarmTotalCount=#{data.alarmTotalCount},
            </if>
            <if test="(colPickMode==0 and data.containsKey('alarmTotalCountIncrement')) or (colPickMode==1 and !data.containsKey('alarmTotalCountIncrement'))">
                a.alarmTotalCount=ifnull(a.alarmTotalCount,0) + #{data.alarmTotalCountIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('pushTotalCount')) or (colPickMode==1 and !data.containsKey('pushTotalCount'))">
                a.pushTotalCount=#{data.pushTotalCount},
            </if>
            <if test="(colPickMode==0 and data.containsKey('pushTotalCountIncrement')) or (colPickMode==1 and !data.containsKey('pushTotalCountIncrement'))">
                a.pushTotalCount=ifnull(a.pushTotalCount,0) + #{data.pushTotalCountIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('uploadMessageTotalCount')) or (colPickMode==1 and !data.containsKey('uploadMessageTotalCount'))">
                a.uploadMessageTotalCount=#{data.uploadMessageTotalCount},
            </if>
            <if test="(colPickMode==0 and data.containsKey('uploadMessageTotalCountIncrement')) or (colPickMode==1 and !data.containsKey('uploadMessageTotalCountIncrement'))">
                a.uploadMessageTotalCount=ifnull(a.uploadMessageTotalCount,0) + #{data.uploadMessageTotalCountIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('downloadMessageTotalCount')) or (colPickMode==1 and !data.containsKey('downloadMessageTotalCount'))">
                a.downloadMessageTotalCount=#{data.downloadMessageTotalCount},
            </if>
            <if test="(colPickMode==0 and data.containsKey('downloadMessageTotalCountIncrement')) or (colPickMode==1 and !data.containsKey('downloadMessageTotalCountIncrement'))">
                a.downloadMessageTotalCount=ifnull(a.downloadMessageTotalCount,0) + #{data.downloadMessageTotalCountIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('year')) or (colPickMode==1 and !data.containsKey('year'))">
                a.year=#{data.year},
            </if>
            <if test="(colPickMode==0 and data.containsKey('yearIncrement')) or (colPickMode==1 and !data.containsKey('yearIncrement'))">
                a.year=ifnull(a.year,0) + #{data.yearIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('month')) or (colPickMode==1 and !data.containsKey('month'))">
                a.month=#{data.month},
            </if>
            <if test="(colPickMode==0 and data.containsKey('monthIncrement')) or (colPickMode==1 and !data.containsKey('monthIncrement'))">
                a.month=ifnull(a.month,0) + #{data.monthIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('day')) or (colPickMode==1 and !data.containsKey('day'))">
                a.day=#{data.day},
            </if>
            <if test="(colPickMode==0 and data.containsKey('dayIncrement')) or (colPickMode==1 and !data.containsKey('dayIncrement'))">
                a.day=ifnull(a.day,0) + #{data.dayIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('createTime')) or (colPickMode==1 and !data.containsKey('createTime'))">
                a.createTime=#{data.createTime},
            </if>
            <if test="(colPickMode==0 and data.containsKey('updateUserId')) or (colPickMode==1 and !data.containsKey('updateUserId'))">
                a.updateUserId=#{data.updateUserId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('updateUserIdIncrement')) or (colPickMode==1 and !data.containsKey('updateUserIdIncrement'))">
                a.updateUserId=ifnull(a.updateUserId,0) + #{data.updateUserIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('updateTime')) or (colPickMode==1 and !data.containsKey('updateTime'))">
                a.updateTime=#{data.updateTime},
            </if>
        </trim>
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </update>
    <!-- 批量更新 -->
    <update id="updateBatch" parameterType="paramDto">
        update mortals_xhx_device_message_stat as a
        <trim prefix="set" suffixOverrides=",">
                        <trim prefix="siteId=(case" suffix="ELSE siteId end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('siteId')) or (colPickMode==1 and !item.containsKey('siteId'))">
                                        when a.id=#{item.id} then #{item.siteId}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('siteIdIncrement')) or (colPickMode==1 and !item.containsKey('siteIdIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.siteId,0) + #{item.siteIdIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                        <trim prefix="productId=(case" suffix="ELSE productId end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('productId')) or (colPickMode==1 and !item.containsKey('productId'))">
                                        when a.id=#{item.id} then #{item.productId}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('productIdIncrement')) or (colPickMode==1 and !item.containsKey('productIdIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.productId,0) + #{item.productIdIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                <trim prefix="productCode=(case" suffix="ELSE productCode end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('productCode')) or (colPickMode==1 and !item.containsKey('productCode'))">
                            when a.id=#{item.id} then #{item.productCode}
                        </if>
                    </foreach>
                </trim>
                <trim prefix="productName=(case" suffix="ELSE productName end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('productName')) or (colPickMode==1 and !item.containsKey('productName'))">
                            when a.id=#{item.id} then #{item.productName}
                        </if>
                    </foreach>
                </trim>
                        <trim prefix="alarmTotalCount=(case" suffix="ELSE alarmTotalCount end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('alarmTotalCount')) or (colPickMode==1 and !item.containsKey('alarmTotalCount'))">
                                        when a.id=#{item.id} then #{item.alarmTotalCount}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('alarmTotalCountIncrement')) or (colPickMode==1 and !item.containsKey('alarmTotalCountIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.alarmTotalCount,0) + #{item.alarmTotalCountIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                        <trim prefix="pushTotalCount=(case" suffix="ELSE pushTotalCount end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('pushTotalCount')) or (colPickMode==1 and !item.containsKey('pushTotalCount'))">
                                        when a.id=#{item.id} then #{item.pushTotalCount}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('pushTotalCountIncrement')) or (colPickMode==1 and !item.containsKey('pushTotalCountIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.pushTotalCount,0) + #{item.pushTotalCountIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                        <trim prefix="uploadMessageTotalCount=(case" suffix="ELSE uploadMessageTotalCount end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('uploadMessageTotalCount')) or (colPickMode==1 and !item.containsKey('uploadMessageTotalCount'))">
                                        when a.id=#{item.id} then #{item.uploadMessageTotalCount}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('uploadMessageTotalCountIncrement')) or (colPickMode==1 and !item.containsKey('uploadMessageTotalCountIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.uploadMessageTotalCount,0) + #{item.uploadMessageTotalCountIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                        <trim prefix="downloadMessageTotalCount=(case" suffix="ELSE downloadMessageTotalCount end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('downloadMessageTotalCount')) or (colPickMode==1 and !item.containsKey('downloadMessageTotalCount'))">
                                        when a.id=#{item.id} then #{item.downloadMessageTotalCount}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('downloadMessageTotalCountIncrement')) or (colPickMode==1 and !item.containsKey('downloadMessageTotalCountIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.downloadMessageTotalCount,0) + #{item.downloadMessageTotalCountIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                        <trim prefix="year=(case" suffix="ELSE year end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('year')) or (colPickMode==1 and !item.containsKey('year'))">
                                        when a.id=#{item.id} then #{item.year}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('yearIncrement')) or (colPickMode==1 and !item.containsKey('yearIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.year,0) + #{item.yearIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                        <trim prefix="month=(case" suffix="ELSE month end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('month')) or (colPickMode==1 and !item.containsKey('month'))">
                                        when a.id=#{item.id} then #{item.month}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('monthIncrement')) or (colPickMode==1 and !item.containsKey('monthIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.month,0) + #{item.monthIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                        <trim prefix="day=(case" suffix="ELSE day end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('day')) or (colPickMode==1 and !item.containsKey('day'))">
                                        when a.id=#{item.id} then #{item.day}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('dayIncrement')) or (colPickMode==1 and !item.containsKey('dayIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.day,0) + #{item.dayIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                <trim prefix="createTime=(case" suffix="ELSE createTime end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('createTime')) or (colPickMode==1 and !item.containsKey('createTime'))">
                            when a.id=#{item.id} then #{item.createTime}
                        </if>
                    </foreach>
                </trim>
                        <trim prefix="updateUserId=(case" suffix="ELSE updateUserId end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('updateUserId')) or (colPickMode==1 and !item.containsKey('updateUserId'))">
                                        when a.id=#{item.id} then #{item.updateUserId}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('updateUserIdIncrement')) or (colPickMode==1 and !item.containsKey('updateUserIdIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.updateUserId,0) + #{item.updateUserIdIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                <trim prefix="updateTime=(case" suffix="ELSE updateTime end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('updateTime')) or (colPickMode==1 and !item.containsKey('updateTime'))">
                            when a.id=#{item.id} then #{item.updateTime}
                        </if>
                    </foreach>
                </trim>
        </trim>
        where id in
        <foreach collection="data.dataList" item="item" index="index" open="(" separator="," close=")">
            #{item.id}
        </foreach>
    </update>
    <!-- 根据主健查询 -->
    <select id="getByKey" parameterType="paramDto" resultMap="DeviceMessageStatEntity-Map">
        select <include refid="_columns"/>
        from mortals_xhx_device_message_stat as a
        where a.id=#{condition.id}
    </select>
    <!-- 根据主健删除 -->
    <delete id="deleteByKey" parameterType="paramDto">
        delete a.* from mortals_xhx_device_message_stat as a where a.id=#{condition.id}
    </delete>
    <!-- 根据主健删除一批，针对单一主健有效 -->
    <delete id="deleteByKeys">
        delete from mortals_xhx_device_message_stat where id in
        <foreach collection="array" item="item" index="index" open="(" separator="," close=")">
            #{item}
        </foreach>
    </delete>
    <!-- 根据主健列表删除一批，针对单一主健有效 -->
    <delete id="deleteByKeyList">
        delete from mortals_xhx_device_message_stat where id in
        <foreach collection="list" item="item" index="index" open="(" separator="," close=")">
            #{item}
        </foreach>
    </delete>

    <!-- 根据对象列表删除一批，针对单一主健有效 -->
    <delete id="deleteByEntityList">
        delete from mortals_xhx_device_message_stat where id in
        <foreach collection="list" item="item" index="index" open="(" separator="," close=")">
            #{item.id}
        </foreach>
    </delete>
    <!-- 根据paramDto删除一批 -->
    <delete id="deleteByMap" parameterType="paramDto">
        delete a.* from mortals_xhx_device_message_stat as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </delete>
    <!-- 获取列表 -->
    <select id="getList" parameterType="paramDto" resultMap="DeviceMessageStatEntity-Map">
        select <include refid="_columns"/>
        from mortals_xhx_device_message_stat as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
        <include refid="_orderCols_"/>
    </select>



    <!-- 获取 -->
    <select id="getListCount" parameterType="paramDto" resultType="int">
        select count(1)
        from mortals_xhx_device_message_stat as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </select>
    <!-- 条件映射 -->
    <sql id="_condition_">
        <if test="condition != null and !condition.isEmpty()">
            <!-- 条件映射-普通条件 -->
            <include refid="_condition_param_">
                <property name="_conditionParam_" value="condition"/>
                <property name="_conditionType_" value="and"/>
            </include>
            <!-- 条件映射-集合之间使用AND，集合中元素使用OR-(list[0].1 or list[0].2) and (list[1].3 or list[1].4) -->
            <if test="condition.containsKey('andConditionList') and !condition.andConditionList.isEmpty()">
                and
                <foreach collection="condition.andConditionList" open="(" close=")" index="index" item="andCondition" separator=" and ">
                    <trim prefixOverrides="or" prefix="(" suffix=")">
                        <include refid="_condition_param_">
                            <property name="_conditionParam_" value="andCondition"/>
                            <property name="_conditionType_" value="or"/>
                        </include>
                    </trim>
                </foreach>
            </if>
            <!-- 条件映射-集合之间使用OR，集合中元素使用AND-(list[0].1 and list[0].2) or (list[1].3 and list[1].4) -->
            <if test="condition.containsKey('orConditionList') and !condition.orConditionList.isEmpty()">
                and
                <foreach collection="condition.orConditionList" open="(" close=")" index="index" item="orCondition" separator=" or ">
                    <trim prefixOverrides="and" prefix="(" suffix=")">
                        <include refid="_condition_param_">
                            <property name="_conditionParam_" value="orCondition"/>
                            <property name="_conditionType_" value="and"/>
                        </include>
                    </trim>
                </foreach>
            </if>
        </if>
    </sql>
    <!-- 条件映射-代参数 -->
    <sql id="_condition_param_">
        <bind name="conditionParamRef" value="${_conditionParam_}"/>
        <if test="conditionParamRef.containsKey('id')">
            <if test="conditionParamRef.id != null">
                ${_conditionType_} a.id=#{${_conditionParam_}.id}
            </if>
        </if>
            <if test="conditionParamRef.containsKey('id')">
                <if test="conditionParamRef.id != null ">
                    ${_conditionType_} a.id = #{${_conditionParam_}.id}
                </if>
                <if test="conditionParamRef.id == null">
                    ${_conditionType_} a.id is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('idList') and conditionParamRef.idList.size() > 0">
                ${_conditionType_} a.id in
                <foreach collection="conditionParamRef.idList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('idNotList') and conditionParamRef.idNotList.size() > 0">
                ${_conditionType_} a.id not in
                <foreach collection="conditionParamRef.idNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('idStart') and conditionParamRef.idStart != null">
                ${_conditionType_} a.id <![CDATA[ >= ]]> #{${_conditionParam_}.idStart}
            </if>
            <if test="conditionParamRef.containsKey('idEnd') and conditionParamRef.idEnd != null">
                ${_conditionType_} a.id <![CDATA[ <= ]]> #{${_conditionParam_}.idEnd}
            </if>

            <if test="conditionParamRef.containsKey('siteId')">
                <if test="conditionParamRef.siteId != null ">
                    ${_conditionType_} a.siteId = #{${_conditionParam_}.siteId}
                </if>
                <if test="conditionParamRef.siteId == null">
                    ${_conditionType_} a.siteId is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('siteIdList') and conditionParamRef.siteIdList.size() > 0">
                ${_conditionType_} a.siteId in
                <foreach collection="conditionParamRef.siteIdList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('siteIdNotList') and conditionParamRef.siteIdNotList.size() > 0">
                ${_conditionType_} a.siteId not in
                <foreach collection="conditionParamRef.siteIdNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('siteIdStart') and conditionParamRef.siteIdStart != null">
                ${_conditionType_} a.siteId <![CDATA[ >= ]]> #{${_conditionParam_}.siteIdStart}
            </if>
            <if test="conditionParamRef.containsKey('siteIdEnd') and conditionParamRef.siteIdEnd != null">
                ${_conditionType_} a.siteId <![CDATA[ <= ]]> #{${_conditionParam_}.siteIdEnd}
            </if>

            <if test="conditionParamRef.containsKey('productId')">
                <if test="conditionParamRef.productId != null ">
                    ${_conditionType_} a.productId = #{${_conditionParam_}.productId}
                </if>
                <if test="conditionParamRef.productId == null">
                    ${_conditionType_} a.productId is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('productIdList') and conditionParamRef.productIdList.size() > 0">
                ${_conditionType_} a.productId in
                <foreach collection="conditionParamRef.productIdList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('productIdNotList') and conditionParamRef.productIdNotList.size() > 0">
                ${_conditionType_} a.productId not in
                <foreach collection="conditionParamRef.productIdNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('productIdStart') and conditionParamRef.productIdStart != null">
                ${_conditionType_} a.productId <![CDATA[ >= ]]> #{${_conditionParam_}.productIdStart}
            </if>
            <if test="conditionParamRef.containsKey('productIdEnd') and conditionParamRef.productIdEnd != null">
                ${_conditionType_} a.productId <![CDATA[ <= ]]> #{${_conditionParam_}.productIdEnd}
            </if>


            <if test="conditionParamRef.containsKey('productCode')">
                <if test="conditionParamRef.productCode != null and conditionParamRef.productCode != ''">
                    ${_conditionType_} a.productCode like #{${_conditionParam_}.productCode}
                </if>
                <if test="conditionParamRef.productCode == null">
                    ${_conditionType_} a.productCode is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('productCodeList') and conditionParamRef.productCodeList.size() > 0">
                ${_conditionType_} a.productCode in
                <foreach collection="conditionParamRef.productCodeList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('productCodeNotList') and conditionParamRef.productCodeNotList.size() > 0">
                ${_conditionType_} a.productCode not in
                <foreach collection="conditionParamRef.productCodeNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>

            <if test="conditionParamRef.containsKey('productName')">
                <if test="conditionParamRef.productName != null and conditionParamRef.productName != ''">
                    ${_conditionType_} a.productName like #{${_conditionParam_}.productName}
                </if>
                <if test="conditionParamRef.productName == null">
                    ${_conditionType_} a.productName is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('productNameList') and conditionParamRef.productNameList.size() > 0">
                ${_conditionType_} a.productName in
                <foreach collection="conditionParamRef.productNameList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('productNameNotList') and conditionParamRef.productNameNotList.size() > 0">
                ${_conditionType_} a.productName not in
                <foreach collection="conditionParamRef.productNameNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('alarmTotalCount')">
                <if test="conditionParamRef.alarmTotalCount != null ">
                    ${_conditionType_} a.alarmTotalCount = #{${_conditionParam_}.alarmTotalCount}
                </if>
                <if test="conditionParamRef.alarmTotalCount == null">
                    ${_conditionType_} a.alarmTotalCount is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('alarmTotalCountList') and conditionParamRef.alarmTotalCountList.size() > 0">
                ${_conditionType_} a.alarmTotalCount in
                <foreach collection="conditionParamRef.alarmTotalCountList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('alarmTotalCountNotList') and conditionParamRef.alarmTotalCountNotList.size() > 0">
                ${_conditionType_} a.alarmTotalCount not in
                <foreach collection="conditionParamRef.alarmTotalCountNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('alarmTotalCountStart') and conditionParamRef.alarmTotalCountStart != null">
                ${_conditionType_} a.alarmTotalCount <![CDATA[ >= ]]> #{${_conditionParam_}.alarmTotalCountStart}
            </if>
            <if test="conditionParamRef.containsKey('alarmTotalCountEnd') and conditionParamRef.alarmTotalCountEnd != null">
                ${_conditionType_} a.alarmTotalCount <![CDATA[ <= ]]> #{${_conditionParam_}.alarmTotalCountEnd}
            </if>

            <if test="conditionParamRef.containsKey('pushTotalCount')">
                <if test="conditionParamRef.pushTotalCount != null ">
                    ${_conditionType_} a.pushTotalCount = #{${_conditionParam_}.pushTotalCount}
                </if>
                <if test="conditionParamRef.pushTotalCount == null">
                    ${_conditionType_} a.pushTotalCount is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('pushTotalCountList') and conditionParamRef.pushTotalCountList.size() > 0">
                ${_conditionType_} a.pushTotalCount in
                <foreach collection="conditionParamRef.pushTotalCountList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('pushTotalCountNotList') and conditionParamRef.pushTotalCountNotList.size() > 0">
                ${_conditionType_} a.pushTotalCount not in
                <foreach collection="conditionParamRef.pushTotalCountNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('pushTotalCountStart') and conditionParamRef.pushTotalCountStart != null">
                ${_conditionType_} a.pushTotalCount <![CDATA[ >= ]]> #{${_conditionParam_}.pushTotalCountStart}
            </if>
            <if test="conditionParamRef.containsKey('pushTotalCountEnd') and conditionParamRef.pushTotalCountEnd != null">
                ${_conditionType_} a.pushTotalCount <![CDATA[ <= ]]> #{${_conditionParam_}.pushTotalCountEnd}
            </if>

            <if test="conditionParamRef.containsKey('uploadMessageTotalCount')">
                <if test="conditionParamRef.uploadMessageTotalCount != null ">
                    ${_conditionType_} a.uploadMessageTotalCount = #{${_conditionParam_}.uploadMessageTotalCount}
                </if>
                <if test="conditionParamRef.uploadMessageTotalCount == null">
                    ${_conditionType_} a.uploadMessageTotalCount is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('uploadMessageTotalCountList') and conditionParamRef.uploadMessageTotalCountList.size() > 0">
                ${_conditionType_} a.uploadMessageTotalCount in
                <foreach collection="conditionParamRef.uploadMessageTotalCountList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('uploadMessageTotalCountNotList') and conditionParamRef.uploadMessageTotalCountNotList.size() > 0">
                ${_conditionType_} a.uploadMessageTotalCount not in
                <foreach collection="conditionParamRef.uploadMessageTotalCountNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('uploadMessageTotalCountStart') and conditionParamRef.uploadMessageTotalCountStart != null">
                ${_conditionType_} a.uploadMessageTotalCount <![CDATA[ >= ]]> #{${_conditionParam_}.uploadMessageTotalCountStart}
            </if>
            <if test="conditionParamRef.containsKey('uploadMessageTotalCountEnd') and conditionParamRef.uploadMessageTotalCountEnd != null">
                ${_conditionType_} a.uploadMessageTotalCount <![CDATA[ <= ]]> #{${_conditionParam_}.uploadMessageTotalCountEnd}
            </if>

            <if test="conditionParamRef.containsKey('downloadMessageTotalCount')">
                <if test="conditionParamRef.downloadMessageTotalCount != null ">
                    ${_conditionType_} a.downloadMessageTotalCount = #{${_conditionParam_}.downloadMessageTotalCount}
                </if>
                <if test="conditionParamRef.downloadMessageTotalCount == null">
                    ${_conditionType_} a.downloadMessageTotalCount is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('downloadMessageTotalCountList') and conditionParamRef.downloadMessageTotalCountList.size() > 0">
                ${_conditionType_} a.downloadMessageTotalCount in
                <foreach collection="conditionParamRef.downloadMessageTotalCountList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('downloadMessageTotalCountNotList') and conditionParamRef.downloadMessageTotalCountNotList.size() > 0">
                ${_conditionType_} a.downloadMessageTotalCount not in
                <foreach collection="conditionParamRef.downloadMessageTotalCountNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('downloadMessageTotalCountStart') and conditionParamRef.downloadMessageTotalCountStart != null">
                ${_conditionType_} a.downloadMessageTotalCount <![CDATA[ >= ]]> #{${_conditionParam_}.downloadMessageTotalCountStart}
            </if>
            <if test="conditionParamRef.containsKey('downloadMessageTotalCountEnd') and conditionParamRef.downloadMessageTotalCountEnd != null">
                ${_conditionType_} a.downloadMessageTotalCount <![CDATA[ <= ]]> #{${_conditionParam_}.downloadMessageTotalCountEnd}
            </if>

            <if test="conditionParamRef.containsKey('year')">
                <if test="conditionParamRef.year != null ">
                    ${_conditionType_} a.year = #{${_conditionParam_}.year}
                </if>
                <if test="conditionParamRef.year == null">
                    ${_conditionType_} a.year is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('yearList') and conditionParamRef.yearList.size() > 0">
                ${_conditionType_} a.year in
                <foreach collection="conditionParamRef.yearList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('yearNotList') and conditionParamRef.yearNotList.size() > 0">
                ${_conditionType_} a.year not in
                <foreach collection="conditionParamRef.yearNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('yearStart') and conditionParamRef.yearStart != null">
                ${_conditionType_} a.year <![CDATA[ >= ]]> #{${_conditionParam_}.yearStart}
            </if>
            <if test="conditionParamRef.containsKey('yearEnd') and conditionParamRef.yearEnd != null">
                ${_conditionType_} a.year <![CDATA[ <= ]]> #{${_conditionParam_}.yearEnd}
            </if>

            <if test="conditionParamRef.containsKey('month')">
                <if test="conditionParamRef.month != null ">
                    ${_conditionType_} a.month = #{${_conditionParam_}.month}
                </if>
                <if test="conditionParamRef.month == null">
                    ${_conditionType_} a.month is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('monthList') and conditionParamRef.monthList.size() > 0">
                ${_conditionType_} a.month in
                <foreach collection="conditionParamRef.monthList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('monthNotList') and conditionParamRef.monthNotList.size() > 0">
                ${_conditionType_} a.month not in
                <foreach collection="conditionParamRef.monthNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('monthStart') and conditionParamRef.monthStart != null">
                ${_conditionType_} a.month <![CDATA[ >= ]]> #{${_conditionParam_}.monthStart}
            </if>
            <if test="conditionParamRef.containsKey('monthEnd') and conditionParamRef.monthEnd != null">
                ${_conditionType_} a.month <![CDATA[ <= ]]> #{${_conditionParam_}.monthEnd}
            </if>

            <if test="conditionParamRef.containsKey('day')">
                <if test="conditionParamRef.day != null ">
                    ${_conditionType_} a.day = #{${_conditionParam_}.day}
                </if>
                <if test="conditionParamRef.day == null">
                    ${_conditionType_} a.day is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('dayList') and conditionParamRef.dayList.size() > 0">
                ${_conditionType_} a.day in
                <foreach collection="conditionParamRef.dayList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('dayNotList') and conditionParamRef.dayNotList.size() > 0">
                ${_conditionType_} a.day not in
                <foreach collection="conditionParamRef.dayNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('dayStart') and conditionParamRef.dayStart != null">
                ${_conditionType_} a.day <![CDATA[ >= ]]> #{${_conditionParam_}.dayStart}
            </if>
            <if test="conditionParamRef.containsKey('dayEnd') and conditionParamRef.dayEnd != null">
                ${_conditionType_} a.day <![CDATA[ <= ]]> #{${_conditionParam_}.dayEnd}
            </if>


            <if test="conditionParamRef.containsKey('createTime')">
                <if test="conditionParamRef.createTime != null ">
                    ${_conditionType_} a.createTime = #{${_conditionParam_}.createTime}
                </if>
                <if test="conditionParamRef.createTime == null">
                    ${_conditionType_} a.createTime is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('createTimeStart') and conditionParamRef.createTimeStart != null and conditionParamRef.createTimeStart!=''">
                ${_conditionType_} a.createTime <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.createTimeStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('createTimeEnd') and conditionParamRef.createTimeEnd != null and conditionParamRef.createTimeEnd!=''">
                ${_conditionType_} a.createTime <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.createTimeEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('updateUserId')">
                <if test="conditionParamRef.updateUserId != null ">
                    ${_conditionType_} a.updateUserId = #{${_conditionParam_}.updateUserId}
                </if>
                <if test="conditionParamRef.updateUserId == null">
                    ${_conditionType_} a.updateUserId is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('updateUserIdList') and conditionParamRef.updateUserIdList.size() > 0">
                ${_conditionType_} a.updateUserId in
                <foreach collection="conditionParamRef.updateUserIdList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('updateUserIdNotList') and conditionParamRef.updateUserIdNotList.size() > 0">
                ${_conditionType_} a.updateUserId not in
                <foreach collection="conditionParamRef.updateUserIdNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('updateUserIdStart') and conditionParamRef.updateUserIdStart != null">
                ${_conditionType_} a.updateUserId <![CDATA[ >= ]]> #{${_conditionParam_}.updateUserIdStart}
            </if>
            <if test="conditionParamRef.containsKey('updateUserIdEnd') and conditionParamRef.updateUserIdEnd != null">
                ${_conditionType_} a.updateUserId <![CDATA[ <= ]]> #{${_conditionParam_}.updateUserIdEnd}
            </if>


            <if test="conditionParamRef.containsKey('updateTime')">
                <if test="conditionParamRef.updateTime != null ">
                    ${_conditionType_} a.updateTime = #{${_conditionParam_}.updateTime}
                </if>
                <if test="conditionParamRef.updateTime == null">
                    ${_conditionType_} a.updateTime is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('updateTimeStart') and conditionParamRef.updateTimeStart != null and conditionParamRef.updateTimeStart!=''">
                ${_conditionType_} a.updateTime <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.updateTimeStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('updateTimeEnd') and conditionParamRef.updateTimeEnd != null and conditionParamRef.updateTimeEnd!=''">
                ${_conditionType_} a.updateTime <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.updateTimeEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
            </if>
    </sql>
    <sql id="_orderCols_">
        <if test="orderColList != null and !orderColList.isEmpty()">
            order by
                    <if test="conditionParamRef.containsKey('idList') and conditionParamRef.idList.size() > 0">
                        field(a.id,
                        <foreach collection="conditionParamRef.idList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
                    <if test="conditionParamRef.containsKey('siteIdList') and conditionParamRef.siteIdList.size() > 0">
                        field(a.siteId,
                        <foreach collection="conditionParamRef.siteIdList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
                    <if test="conditionParamRef.containsKey('productIdList') and conditionParamRef.productIdList.size() > 0">
                        field(a.productId,
                        <foreach collection="conditionParamRef.productIdList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
                    <if test="conditionParamRef.containsKey('alarmTotalCountList') and conditionParamRef.alarmTotalCountList.size() > 0">
                        field(a.alarmTotalCount,
                        <foreach collection="conditionParamRef.alarmTotalCountList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
                    <if test="conditionParamRef.containsKey('pushTotalCountList') and conditionParamRef.pushTotalCountList.size() > 0">
                        field(a.pushTotalCount,
                        <foreach collection="conditionParamRef.pushTotalCountList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
                    <if test="conditionParamRef.containsKey('uploadMessageTotalCountList') and conditionParamRef.uploadMessageTotalCountList.size() > 0">
                        field(a.uploadMessageTotalCount,
                        <foreach collection="conditionParamRef.uploadMessageTotalCountList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
                    <if test="conditionParamRef.containsKey('downloadMessageTotalCountList') and conditionParamRef.downloadMessageTotalCountList.size() > 0">
                        field(a.downloadMessageTotalCount,
                        <foreach collection="conditionParamRef.downloadMessageTotalCountList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
                    <if test="conditionParamRef.containsKey('yearList') and conditionParamRef.yearList.size() > 0">
                        field(a.year,
                        <foreach collection="conditionParamRef.yearList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
                    <if test="conditionParamRef.containsKey('monthList') and conditionParamRef.monthList.size() > 0">
                        field(a.month,
                        <foreach collection="conditionParamRef.monthList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
                    <if test="conditionParamRef.containsKey('dayList') and conditionParamRef.dayList.size() > 0">
                        field(a.day,
                        <foreach collection="conditionParamRef.dayList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
                    <if test="conditionParamRef.containsKey('updateUserIdList') and conditionParamRef.updateUserIdList.size() > 0">
                        field(a.updateUserId,
                        <foreach collection="conditionParamRef.updateUserIdList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
            <trim suffixOverrides=","  suffix="">
                <foreach collection="orderColList" open="" close="" index="index" item="item" separator=",">
                     a.${item.colName} ${item.sortKind}
                </foreach>
            </trim>
        </if>
        <if test="(orderColList == null or orderColList.isEmpty()) and orderCol != null and !orderCol.isEmpty()">
            order by
                    <if test="conditionParamRef.containsKey('idList') and conditionParamRef.idList.size() > 0">
                        field(a.id,
                        <foreach collection="conditionParamRef.idList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
                    <if test="conditionParamRef.containsKey('siteIdList') and conditionParamRef.siteIdList.size() > 0">
                        field(a.siteId,
                        <foreach collection="conditionParamRef.siteIdList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
                    <if test="conditionParamRef.containsKey('productIdList') and conditionParamRef.productIdList.size() > 0">
                        field(a.productId,
                        <foreach collection="conditionParamRef.productIdList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
                    <if test="conditionParamRef.containsKey('alarmTotalCountList') and conditionParamRef.alarmTotalCountList.size() > 0">
                        field(a.alarmTotalCount,
                        <foreach collection="conditionParamRef.alarmTotalCountList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
                    <if test="conditionParamRef.containsKey('pushTotalCountList') and conditionParamRef.pushTotalCountList.size() > 0">
                        field(a.pushTotalCount,
                        <foreach collection="conditionParamRef.pushTotalCountList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
                    <if test="conditionParamRef.containsKey('uploadMessageTotalCountList') and conditionParamRef.uploadMessageTotalCountList.size() > 0">
                        field(a.uploadMessageTotalCount,
                        <foreach collection="conditionParamRef.uploadMessageTotalCountList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
                    <if test="conditionParamRef.containsKey('downloadMessageTotalCountList') and conditionParamRef.downloadMessageTotalCountList.size() > 0">
                        field(a.downloadMessageTotalCount,
                        <foreach collection="conditionParamRef.downloadMessageTotalCountList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
                    <if test="conditionParamRef.containsKey('yearList') and conditionParamRef.yearList.size() > 0">
                        field(a.year,
                        <foreach collection="conditionParamRef.yearList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
                    <if test="conditionParamRef.containsKey('monthList') and conditionParamRef.monthList.size() > 0">
                        field(a.month,
                        <foreach collection="conditionParamRef.monthList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
                    <if test="conditionParamRef.containsKey('dayList') and conditionParamRef.dayList.size() > 0">
                        field(a.day,
                        <foreach collection="conditionParamRef.dayList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
                    <if test="conditionParamRef.containsKey('updateUserIdList') and conditionParamRef.updateUserIdList.size() > 0">
                        field(a.updateUserId,
                        <foreach collection="conditionParamRef.updateUserIdList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
            <trim suffixOverrides=","  suffix="">
                    <if test="orderCol.containsKey('id')">
                        a.id
                        <if test='orderCol.id != null and "DESC".equalsIgnoreCase(orderCol.id)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('siteId')">
                        a.siteId
                        <if test='orderCol.siteId != null and "DESC".equalsIgnoreCase(orderCol.siteId)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('productId')">
                        a.productId
                        <if test='orderCol.productId != null and "DESC".equalsIgnoreCase(orderCol.productId)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('productCode')">
                        a.productCode
                        <if test='orderCol.productCode != null and "DESC".equalsIgnoreCase(orderCol.productCode)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('productName')">
                        a.productName
                        <if test='orderCol.productName != null and "DESC".equalsIgnoreCase(orderCol.productName)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('alarmTotalCount')">
                        a.alarmTotalCount
                        <if test='orderCol.alarmTotalCount != null and "DESC".equalsIgnoreCase(orderCol.alarmTotalCount)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('pushTotalCount')">
                        a.pushTotalCount
                        <if test='orderCol.pushTotalCount != null and "DESC".equalsIgnoreCase(orderCol.pushTotalCount)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('uploadMessageTotalCount')">
                        a.uploadMessageTotalCount
                        <if test='orderCol.uploadMessageTotalCount != null and "DESC".equalsIgnoreCase(orderCol.uploadMessageTotalCount)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('downloadMessageTotalCount')">
                        a.downloadMessageTotalCount
                        <if test='orderCol.downloadMessageTotalCount != null and "DESC".equalsIgnoreCase(orderCol.downloadMessageTotalCount)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('year')">
                        a.year
                        <if test='orderCol.year != null and "DESC".equalsIgnoreCase(orderCol.year)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('month')">
                        a.month
                        <if test='orderCol.month != null and "DESC".equalsIgnoreCase(orderCol.month)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('day')">
                        a.day
                        <if test='orderCol.day != null and "DESC".equalsIgnoreCase(orderCol.day)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('createTime')">
                        a.createTime
                        <if test='orderCol.createTime != null and "DESC".equalsIgnoreCase(orderCol.createTime)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('updateUserId')">
                        a.updateUserId
                        <if test='orderCol.updateUserId != null and "DESC".equalsIgnoreCase(orderCol.updateUserId)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('updateTime')">
                        a.updateTime
                        <if test='orderCol.updateTime != null and "DESC".equalsIgnoreCase(orderCol.updateTime)'>DESC</if>
                        ,
                    </if>
            </trim>
        </if>


    </sql>
    <sql id="_group_by_">
        <if test="groupList != null and !groupList.isEmpty()">
            GROUP BY
            <trim suffixOverrides=","  suffix="">
                <foreach collection="groupList" open="" close="" index="index" item="item" separator=",">
                    ${item}
                </foreach>
            </trim>
        </if>
    </sql>
</mapper>